var goals = require('hivemind_goals')
var Overlord = require('overlords_overlord');

var hivemind = {

    /* Lets the hivemind run. That means at the start initializing the hivemind's memory or advancing its state*/
    run: function () {
        if (Memory.last_tick === undefined) {
            hivemind.initialize_memory();
        }
        else {
            hivemind.advance_state();
        }
    },

    /* Initializes memory variables. Expected to be only called once at the start of the entire script. */
    initialize_memory: function () {
        console.log("Initializing memory. Creating overlord \"Adam\"")
        Memory.last_tick = 0;
        var init_overlord = new Overlord("Adam", goals.INITIAL_SETUP);

        for(var curr_spawn_name in Game.spawns) {  // at the very start each spawn (the only spawn) needs to start set up the room.
            Game.spawns[curr_spawn_name].memory.owner = init_overlord.id;
        }
    },


    /* Starts querying global info Updates the hivemind state to decide on goals */
    advance_state: function () {
        if (Memory.last_tick === 0) { // last_tick is used as a makeshift timestamp to remember if something was this tick or the last.
            Memory.last_tick = 1;
            //console.log("Tick is now 0");
        }
        else {
            Memory.last_tick = 0;
            //console.log("Tick is now 1");
        }
    },
};

module.exports = hivemind;
